%global pypi_name lark-parser

Summary:        Lark is a modern general-purpose parsing library for Python
Name:           python-%{pypi_name}
Version:        1.1.7
Release:        4%{?dist}
License:        MIT
Url:            https://github.com/lark-parser/lark

# we must choose pypi_source. tar from github may lost some files
Source0:        %{pypi_source lark}

BuildArch:      noarch

%description
Lark is a modern general-purpose parsing library for Python.

Lark focuses on simplicity and power. It lets you choose between two parsing algorithms:

Earley : Parses all context-free grammars (even ambiguous ones)!  It is the default.

LALR(1): Only LR grammars. Outperforms PLY and most if not all other pure-python parsing libraries.

Both algorithms are written in Python and can be used interchangeably with the same grammar (aside
for algorithmic restrictions).  See "Comparison to other parsers" for more details.

Lark can auto magically build an AST from your grammar, without any more code on your part.

Features:

- EBNF grammar with a little extra
- Earley & LALR(1)
- Builds an AST auto magically based on the grammar
- Automatic line & column tracking
- Automatic token collision resolution (unless both tokens are regexps)
- Python 2 & 3 compatible
- Unicode fully supported

%package -n python3-%{pypi_name}
Summary:        Lark is a modern general-purpose parsing library for Python
BuildRequires:  python3-devel python3-setuptools
Provides:       python3.11dist(lark-parser) = %{version}
Provides:       python3dist(lark-parser) = %{version}

%description -n python3-%{pypi_name}
Lark is a modern general-purpose parsing library for Python.

Lark focuses on simplicity and power. It lets you choose between two parsing algorithms:

Earley : Parses all context-free grammars (even ambiguous ones)!  It is the default.

LALR(1): Only LR grammars. Outperforms PLY and most if not all other pure-python parsing libraries.

Both algorithms are written in Python and can be used interchangeably with the same grammar (aside
for algorithmic restrictions).  See "Comparison to other parsers" for more details.

Lark can auto magically build an AST from your grammar, without any more code on your part.

Features:

- EBNF grammar with a little extra
- Earley & LALR(1)
- Builds an AST auto magically based on the grammar
- Automatic line & column tracking
- Automatic token collision resolution (unless both tokens are regexps)
- Python 2 & 3 compatible
- Unicode fully supported

%prep
%autosetup -p1 -n lark-%{version}

# Fix wrong-file-end-of-line-encoding.
sed -i 's/\r$//' README.md examples/*.py

%generate_buildrequires
%pyproject_buildrequires

%build
%pyproject_wheel

%install
%pyproject_install
%pyproject_save_files lark

%check
%{python3} -m tests

%files -n python3-%{pypi_name}
%license LICENSE
%doc README.md examples
%{python3_sitelib}/lark-*.dist-info
%{python3_sitelib}/lark/

%changelog
* Fri Aug 16 2024 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 1.1.7-4
- Rebuilt for loongarch release

* Sat Oct 7 2023 Shuo Wang <abushwang@tencent.com> - 1.1.7-3
- update tar for common.lark

* Wed Sep 27 2023 cunshunxia <cunshunxia@tencent.com> - 1.1.7-2
- provide dist for compat with python-hypothesmith

* Fri Sep 22 2023 jackeyji <jackeyji@tencent.com> - 1.1.7-1
- upgrade to 1.1.7

* Tue Sep 19 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.9.0-5
- Rebuilt for python 3.11

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.9.0-4
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.9.0-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 0.9.0-2
- Rebuilt for OpenCloudOS Stream 23

* Thu Mar 16 2023 Shuo Wang <abushwang@tencent.com> - 0.9.0-1
- initial build
